<template>
  <doc-example-wrapper v-if="!loading" class="-mbl doc-playground" :min-height="doc.playground.minHeight" :background="doc.playground.background">
    <component :is="doc.displayName" v-bind="activeProps" v-model="internalValue">
      <!-- eslint-disable vue/v-slot-style -->
      <template v-for="name in activeSlots" :key="name" v-slot:[name]>
        <doc-v-html :html="slotValues[name]" />
      </template>
      <!-- eslint-enable vue/v-slot-style -->
    </component>

    <template v-if="doc.playground.bindValue" #aside>
      <pre><strong>Value:</strong> {{ internalValue }}</pre>
    </template>
  </doc-example-wrapper>
  <rui-loading v-else text="Loading component..." />

  <div class="_filters">
    <div class="_filters__section">
      <div class="_filters__section__title">Presets</div>
      <select v-model="selectedPreset" :disabled="Object.keys(presets).length === 1">
        <option v-for="name in Object.keys(presets)" :key="name" :value="name">{{ name }}</option>
      </select>
    </div>
  </div>

  <div class="-grid-2 -gap">
    <div>
      <h2>Props</h2>

      <rui-empty v-if="doc.props.length === 0" icon="doc:info" inline>This component has no props</rui-empty>

      <table>
        <tbody>
          <template v-for="(props, group) in propGroups" :key="group">
            <tr v-if="group !== 'default'" class="-bg-default--alt -mtd"><th colspan="2">{{ group }}</th></tr>
            <tr v-for="prop in props" :key="prop.name">
              <td class="-text--right"><code>{{ prop.name }}</code></td>
              <td>
                <rui-icon-text v-if="doc.playground.disabledProps.includes(prop.name)"
                               variant="mute"
                               text="This prop is disabled in the playground"
                               size="small"
                               icon="doc:warning" />
                <doc-prop-control v-else v-model="propValues[prop.name]" :prop="prop" />
              </td>
            </tr>
          </template>
        </tbody>
      </table>
    </div>

    <div>
      <h2>Slots</h2>

      <rui-empty v-if="doc.slots.length === 0" icon="doc:info" inline>This component has no slot</rui-empty>

      <rui-form v-else
                :cancellable="false"
                :disable-submit="loading"
                submit-button-icon="doc:check"
                submit-button-title="Apply changes"
                fixed-actions
                @submit.prevent="applySlotChanges">
        <table>
          <tr v-for="slot in doc.slots" :key="slot.name">
            <td class="-text--right">
              <label :for="`slot_${slot.name}`"><code>{{ slot.name }}</code></label>
            </td>
            <td>
              <textarea :id="`slot_${slot.name}`" v-model="formSlotValues[slot.name]" :name="slot.name" rows="3" />
              <doc-markdown-renderer v-if="slot.description" class="rui-field__help" :raw="slot.description" />
            </td>
          </tr>
        </table>
      </rui-form>
    </div>
  </div>
</template>

<script>
import { RuiEmpty, RuiForm, RuiIconText, RuiLoading } from '../../../src/components/index.js'
import DocExampleWrapper from '../../components/ExampleWrapper/ExampleWrapper.vue'
import DocMarkdownRenderer from '../../components/MarkdownRenderer/MarkdownRenderer.vue'
import DocPropControl from '../../components/PropControl/PropControl.vue'
import DocVHtml from '../../components/VHtml/VHtml.js'

export default {
  name: 'DocComponentPlayground',
  components: { DocMarkdownRenderer, DocVHtml, DocExampleWrapper, DocPropControl, RuiLoading, RuiEmpty, RuiIconText, RuiForm },
  data () {
    const doc = this.$getDoc(this.$route.params.component)
    let internalValue = null
    if (Object.hasOwnProperty.call(doc.playground, 'bindValue')) {
      internalValue = doc.playground.bindValue
    }
    return {
      loading: false,
      doc,
      presets: doc.playground.presets,
      selectedPreset: Object.keys(doc.playground.presets)[0],
      // Forms
      propValues: {},
      slotValues: {},
      formSlotValues: {},
      internalValue,
    }
  },
  computed: {
    // If props are not filtered, entries with empty values will still be bound, resulting in the empty slot being
    // used
    activeSlots () {
      return Object.keys(this.slotValues).filter(k => {
        if (this.slotValues[k] === null) return false

        return this.slotValues[k].trim() !== ''
      })
    },
    // If props are not filtered, entries with null or empty values will still be bound, resulting in the defaults not
    // applying on the component
    activeProps () {
      const props = {}

      Object.keys(this.propValues).filter(k => !(this.propValues[k] === null || this.propValues[k] === ''))
        .forEach((k) => { props[k] = this.propValues[k] })

      return props
    },
    propGroups () {
      const groups = { default: [] }

      this.doc.props.forEach((p) => {
        if (!groups[p.group]) groups[p.group] = []
        groups[p.group].push(p)
      })

      return groups
    },
  },
  methods: {
    applySlotChanges () {
      this.loading = true
      this.slotValues = { ...this.formSlotValues }
      this.$nextTick(() => {
        this.loading = false
      })
    },
    apply (presetName) {
      this.loading = true

      const preset = { ...this.presets[presetName] }

      // Props
      const propValues = {}
      if (this.doc.props) {
        this.doc.props.forEach((p) => {
          if (Object.prototype.hasOwnProperty.call(preset.props, p.name)) {
            propValues[p.name] = preset.props[p.name]
          } else {
            propValues[p.name] = null
          }
        })
      }

      // Slots
      const slotValues = {}
      if (this.doc.slots) {
        this.doc.slots.map(p => p).forEach((p) => {
          if (Object.prototype.hasOwnProperty.call(preset.slots, p.name)) {
            slotValues[p.name] = preset.slots[p.name]
          } else {
            slotValues[p.name] = null
          }
        })
      }
      this.propValues = propValues
      this.formSlotValues = { ...slotValues }
      this.slotValues = slotValues
      this.$nextTick(() => { this.loading = false })
    },
  },
  created () {
    this.apply(this.selectedPreset)
  },
  watch: {
    selectedPreset (newValue, oldValue) {
      if (newValue !== oldValue) this.apply(newValue)
    },
  },
}
</script>
